// MyClockCtrl.cpp : Implementation of the CMyClockCtrl ActiveX Control class.

#include "stdafx.h"
#include "MyClock.h"
#include "MyClockCtrl.h"
#include "MyClockPropPage.h"
#include ".\myclockctrl.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNCREATE(CMyClockCtrl, COleControl)



// Message map

BEGIN_MESSAGE_MAP(CMyClockCtrl, COleControl)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
	ON_WM_CREATE()
	ON_WM_TIMER()
	ON_WM_DESTROY()
END_MESSAGE_MAP()



// Dispatch map

BEGIN_DISPATCH_MAP(CMyClockCtrl, COleControl)
	DISP_FUNCTION_ID(CMyClockCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
	DISP_STOCKPROP_BACKCOLOR()
	DISP_STOCKPROP_FORECOLOR()
	DISP_PROPERTY_NOTIFY_ID(CMyClockCtrl, "UpdateInterval", dispidUpdateInterval, m_UpdateInterval, OnUpdateIntervalChanged, VT_I4)
	DISP_STOCKFUNC_REFRESH()
	DISP_FUNCTION_ID(CMyClockCtrl, "StartClock", dispidStartClock, StartClock, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION_ID(CMyClockCtrl, "StopClock", dispidStopClock, StopClock, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION_ID(CMyClockCtrl, "BeepClock", dispidBeepClock, BeepClock, VT_EMPTY, VTS_UI1)
END_DISPATCH_MAP()



// Event map

BEGIN_EVENT_MAP(CMyClockCtrl, COleControl)
	EVENT_STOCK_CLICK()
	EVENT_STOCK_DBLCLICK()
	EVENT_CUSTOM_ID("NewMinute", eventidNewMinute, NewMinute, VTS_NONE)
END_EVENT_MAP()



// Property pages

// TODO: Add more property pages as needed.  
// Remember to increase the count!
BEGIN_PROPPAGEIDS(CMyClockCtrl, 3)
	PROPPAGEID(CMyClockPropPage::guid)
	PROPPAGEID(CLSID_CColorPropPage)
	PROPPAGEID(CLSID_CFontPropPage)
END_PROPPAGEIDS(CMyClockCtrl)



// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CMyClockCtrl, "MYCLOCK.MyClockCtrl.1",
	0x21fd49d6, 0x3d30, 0x40ea, 0xaf, 0x5a, 0x4, 0x3a, 0xbd, 0xad, 0x80, 0x74)



// Type library ID and version

IMPLEMENT_OLETYPELIB(CMyClockCtrl, _tlid, _wVerMajor, _wVerMinor)



// Interface IDs

const IID BASED_CODE IID_DMyClock =
		{ 0x15870940, 0x495C, 0x4FFD, { 0x8C, 0x1A, 0x32, 0xB6, 0xC2, 0xC8, 0x7C, 0x25 } };
const IID BASED_CODE IID_DMyClockEvents =
		{ 0x1E47AE17, 0xF799, 0x44FC, { 0x9C, 0x13, 0x9E, 0x3D, 0xD2, 0x3D, 0x55, 0x40 } };



// Control type information

static const DWORD BASED_CODE _dwMyClockOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CMyClockCtrl, IDS_MYCLOCK, _dwMyClockOleMisc)



// CMyClockCtrl::CMyClockCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CMyClockCtrl

BOOL CMyClockCtrl::CMyClockCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_MYCLOCK,
			IDB_MYCLOCK,
			afxRegApartmentThreading,
			_dwMyClockOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}



// CMyClockCtrl::CMyClockCtrl - Constructor

CMyClockCtrl::CMyClockCtrl()
{
	InitializeIIDs(&IID_DMyClock, &IID_DMyClockEvents);
	// TODO: Initialize your control's instance data here.

	//   
	SetInitialSize(300, 15);
	//    
	flagClock = true;
	flagBeep = false;
}



// CMyClockCtrl::~CMyClockCtrl - Destructor

CMyClockCtrl::~CMyClockCtrl()
{
	// TODO: Cleanup your control's instance data here.
}



// CMyClockCtrl::OnDraw - Drawing function

void CMyClockCtrl::OnDraw(
			CDC* pdc, 
			const CRect& rcBounds, 
			const CRect& rcInvalid)
{
	if (!pdc)
		return;

	// TODO: Replace the following code with your own drawing code.

	//     (..  )
	//    ForeColor
 	pdc->SetTextColor(TranslateColor(GetForeColor()));

	//    
	pdc->SetBkMode(TRANSPARENT);

	//       BackColor
 	CBrush bkBrush(TranslateColor(GetBackColor()));

	//   ,   BackColor
	pdc->FillRect(rcBounds, &bkBrush);

	//        
	if(flagClock){ //  
		GetCurDate();
		m_str = m_strDate;
		GetCurTime();
		m_str += m_strTime;
	}

	pdc->ExtTextOut(rcBounds.left,
		rcBounds.top,
		ETO_CLIPPED,
		rcBounds,
		m_str,
		m_str.GetLength(),
		NULL);

	//       NewMinute
	CTime curTime = CTime::GetCurrentTime();
	if(curTime.Format("%S") == CString("00"))
		NewMinute();
}



// CMyClockCtrl::DoPropExchange - Persistence support

void CMyClockCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

	//   UpdateInterval
	//  1000
	PX_Long(pPX, _T("UpdateInterval"), m_UpdateInterval, 1000);
}



// CMyClockCtrl::OnResetState - Reset control to default state

void CMyClockCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}



// CMyClockCtrl::AboutBox - Display an "About" box to the user

void CMyClockCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_MYCLOCK);
	dlgAbout.DoModal();
}



//  -  m_strDate  
void CMyClockCtrl::GetCurDate(void)
{
	//  
	char *month[] = {""
					,""
					,""
					,""
					,""
					,""
					,""
					,""
					,""
					,""
					,""
					,""};
	//   
	char *week[] = { "" 
					,""
					,""
					,""
					,""
					,""
					,"" };
	
	int m_day, m_month, m_week, m_year;
	
	//   
	CTime curTime = CTime::GetCurrentTime();
	
	m_day = curTime.GetDay();			//  
	m_month = curTime.GetMonth();		// 1 - 
	m_week = curTime.GetDayOfWeek();	// 1 - 
	m_year = curTime.GetYear();			// 
	
	char tmp[5]; //    ,   -
	itoa(m_day, tmp, 10);//       
	
	m_strDate = ""; //   
	m_strDate += tmp;
	m_strDate += " ";
	m_strDate += month[m_month - 1];
	m_strDate += " (";
	m_strDate += week[m_week - 1];
	m_strDate += ") - ";
	
	itoa(m_year, tmp, 10);	//  -  -
	m_strDate += tmp;
	m_strDate += " .";
}

//   m_strTime  
void CMyClockCtrl::GetCurTime(void)
{
	//   
	CTime curTime = CTime::GetCurrentTime();
	
	//      
	m_strTime = "  "; //  
	m_strTime += curTime.Format("%H:%M:%S");
}

int CMyClockCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (COleControl::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  Add your specialized creation code here

	//  
	SetTimer(ID_CLOCK_TIMER, (UINT)m_UpdateInterval, NULL);

	return 0;
}

void CMyClockCtrl::OnTimer(UINT nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	
	//     OnDraw()
	InvalidateControl();

	COleControl::OnTimer(nIDEvent);
}

void CMyClockCtrl::OnDestroy()
{
	COleControl::OnDestroy();

	// TODO: Add your message handler code here
	
	//  
	KillTimer(ID_CLOCK_TIMER); 
}

void CMyClockCtrl::OnUpdateIntervalChanged(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	//  ,   
	//   
	if(m_UpdateInterval < 0){
		MessageBox(" !!!"
			       "\n 1000!!!");
		m_UpdateInterval = 1000;
	}

	//     ,
	//    UpdateInterval
	SetTimer(ID_CLOCK_TIMER, (UINT)m_UpdateInterval, NULL);

	SetModifiedFlag();
}

void CMyClockCtrl::StartClock(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here
	flagClock = true; //  
}

void CMyClockCtrl::StopClock(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here
	flagClock = false; //  
}

void CMyClockCtrl::BeepClock(BYTE beep)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here
	flagBeep = beep ? true : false;
}
